unit UMainForm;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Graphics, FMX.Forms, FMX.Dialogs, FMX.TabControl, FMX.StdCtrls,
  System.Actions, FMX.ActnList, FMX.Gestures, FMX.ListView.Types,
  Data.Bind.GenData, Data.Bind.Components, Data.Bind.ObjectScope, FMX.ListView,
  System.Rtti, System.Bindings.Outputs, Fmx.Bind.Editors, Data.Bind.EngExt,
  Fmx.Bind.DBEngExt, FMX.Objects, IPPeerClient, REST.Client, FMX.Edit,
  FMX.Layouts, FMX.Memo, Data.DB, Datasnap.DBClient, REST.Response.Adapter,
  FMX.Grid, Fmx.Bind.Grid, Data.Bind.Grid, Data.Bind.DBScope, FMX.StdActns;

type
  TFMain = class(TForm)
    ActionList1: TActionList;
    TabControl2: TTabControl;
    tsBusqueda: TTabItem;
    tsResult: TTabItem;
    ChangetsResult: TChangeTabAction;
    ToolBar1: TToolBar;
    lblTitle1: TLabel;
    ToolBar2: TToolBar;
    lblTitle2: TLabel;
    ChangetsBusqueda: TChangeTabAction;
    GestureManager1: TGestureManager;
    ListView1: TListView;
    PrototypeBindSource1: TPrototypeBindSource;
    BindingsList1: TBindingsList;
    tsDetalle: TTabItem;
    imgInfo: TImage;
    RESTRequest1: TRESTRequest;
    RESTClient1: TRESTClient;
    RESTResponse1: TRESTResponse;
    Label1: TLabel;
    GroupBox1: TGroupBox;
    edtId: TEdit;
    GroupBox2: TGroupBox;
    edtNombre: TEdit;
    ToolBar3: TToolBar;
    Label2: TLabel;
    SpeedButton1: TSpeedButton;
    ChangetsDetalle: TChangeTabAction;
    RESTResponseDataSetAdapter1: TRESTResponseDataSetAdapter;
    ClientDataSet1: TClientDataSet;
    BindSourceDB1: TBindSourceDB;
    Image4: TImage;
    lblNombre: TLabel;
    lblApellidos: TLabel;
    LinkPropertyToFieldText: TLinkPropertyToField;
    LinkPropertyToFieldText2: TLinkPropertyToField;
    Rectangle1: TRectangle;
    lbltelefono: TLabel;
    Label3: TLabel;
    lblext: TLabel;
    LinkPropertyToFieldText3: TLinkPropertyToField;
    LinkPropertyToFieldText4: TLinkPropertyToField;
    LinkListControlToField1: TLinkListControlToField;
    Image5: TImage;
    Image6: TImage;
    Image7: TImage;
    tsInfo: TTabItem;
    ToolBar4: TToolBar;
    Label4: TLabel;
    SpeedButton2: TSpeedButton;
    Image2: TImage;
    Label5: TLabel;
    Label6: TLabel;
    Image1: TImage;
    btnBuscarNombre: TButton;
    btnBuscarId: TButton;
    Image3: TImage;
    Image8: TImage;
    lblDepartamento: TLabel;
    LinkPropertyToFieldText5: TLinkPropertyToField;
    btnBack: TSpeedButton;
    imgExit: TImage;
    WindowClose1: TWindowClose;
    SpeedButton3: TSpeedButton;
    Button1: TButton;
    Button2: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word; var KeyChar: Char;
      Shift: TShiftState);
    procedure TabControl1Gesture(Sender: TObject;
      const EventInfo: TGestureEventInfo; var Handled: Boolean);
    procedure imgBuscaIdClick(Sender: TObject);
    procedure RESTRequest1AfterExecute(Sender: TCustomRESTRequest);
    procedure imgBuscaNombreClick(Sender: TObject);
    procedure ListView1ItemClick(const Sender: TObject;
      const AItem: TListViewItem);
    procedure edtIdKeyDown(Sender: TObject; var Key: Word; var KeyChar: Char;
      Shift: TShiftState);
    procedure edtNombreKeyDown(Sender: TObject; var Key: Word;
      var KeyChar: Char; Shift: TShiftState);
    procedure imgInfoClick(Sender: TObject);
    procedure Label6Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure ListView1Click(Sender: TObject);
    procedure imgExitClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    procedure SearchUsuarios(AId:integer); overload;
    procedure SearchUsuarios(ANombre:string); overload;
  public
    { Public declarations }
  end;

const
  URL_BASE = 'http://neftali.clubdelphi.com/agenda/listadoREST2.php';

var
  FMain: TFMain;

implementation

{$R *.fmx}

uses
{$IFDEF ANDROID}
  Androidapi.JNI.GraphicsContentViewText,
  FMX.Helpers.Android,
{$ENDIF}
{$IFDEF MSWINDOWS}
  ShellAPI,
{$ENDIF}
  REST.Json;

procedure TFMain.edtIdKeyDown(Sender: TObject; var Key: Word; var KeyChar: Char;
  Shift: TShiftState);
begin
  if (key = 13)  then
    imgBuscaIdClick(nil);
end;

procedure TFMain.edtNombreKeyDown(Sender: TObject; var Key: Word;
  var KeyChar: Char; Shift: TShiftState);
begin
  if (key = 13)  then
    imgBuscaNombreClick(nil);
end;

procedure TFMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := TCloseAction.caFree;
end;

procedure TFMain.FormCreate(Sender: TObject);
begin
  { This defines the default active tab at runtime }
//  TabControl1.ActiveTab := TabItem1;
{$IFDEF ANDROID}
  { This hides the toolbar back button on Android }
  btnBack.Visible := False;
{$ENDIF}

 TabControl2.ActiveTab := tsBusqueda;
end;

procedure TFMain.FormKeyUp(Sender: TObject; var Key: Word;
  var KeyChar: Char; Shift: TShiftState);
begin
  if Key = vkHardwareBack then
  begin
{    if (TabControl1.ActiveTab = TabItem1) and (TabControl2.ActiveTab = TabItem6) then
    begin
      ChangeTabAction2.Tab := TabItem5;
      ChangeTabAction2.ExecuteTarget(Self);
      ChangeTabAction2.Tab := TabItem6;
      Key := 0;
    end;
}
  end;
end;

procedure TFMain.imgBuscaIdClick(Sender: TObject);
begin
  SearchUsuarios(StrToIntDef(edtId.Text, -1));
  edtNombre.Text := '';
  TabControl2.ActiveTab := tsResult;
end;

procedure TFMain.imgBuscaNombreClick(Sender: TObject);
begin
  SearchUsuarios(edtNombre.Text);
  edtId.Text := '';
  TabControl2.ActiveTab := tsResult;

end;

procedure TFMain.imgExitClick(Sender: TObject);
begin
  Self.Hide;
  Self.Close;
  Halt(0);
end;

procedure TFMain.imgInfoClick(Sender: TObject);
begin
  TabControl2.ActiveTab := tsInfo;
end;

procedure TFMain.Label6Click(Sender: TObject);
{$IFDEF ANDROID}
var
  Intent: JIntent;
begin
  Intent := TJIntent.Create;
  Intent.setAction(TJIntent.JavaClass.ACTION_VIEW);
  Intent.setData(StrToJURI(Label6.Text));
  SharedActivity.startActivity(Intent);
{$ENDIF}
{$IFDEF MSWINDOWS}
begin
  ShellExecute(0, 'open', PChar(Label6.Text), nil, nil, 1);
{$ENDIF}
{$IFDEF IOS}
begin
{$ENDIF}

end;

procedure TFMain.ListView1Click(Sender: TObject);
begin
  // activar el detalle
  ChangetsDetalle.Execute;
  TabControl2.ActiveTab := tsdetalle;
end;

procedure TFMain.ListView1ItemClick(const Sender: TObject;
  const AItem: TListViewItem);
begin
  // activar el detalle
  ChangetsDetalle.Execute;
  TabControl2.ActiveTab := tsdetalle;
end;

procedure TFMain.RESTRequest1AfterExecute(
  Sender: TCustomRESTRequest);
begin
  if assigned(RESTResponse1.JSONValue) then
  begin
    //memo1.Lines.Text := TJson.Format(RESTResponse1.JSONValue)
  end
  else
  begin
    //memo1.Lines.Text := RESTResponse1.Content;
  end;

end;

procedure TFMain.SearchUsuarios(AId: integer);
var
  sURL:string;
begin
  sURL := URL_BASE + '?user=' + IntToStr(AId);
  RESTClient1.BaseURL := sURL;
  // Busqueda
  RESTRequest1.Execute;
end;

procedure TFMain.SearchUsuarios(ANombre: string);
var
  sURL:string;
begin
  sURL := URL_BASE + '?nom=' + ANombre;
  RESTClient1.BaseURL := sURL;
  // Busqueda
  RESTRequest1.Execute;
end;

procedure TFMain.SpeedButton2Click(Sender: TObject);
begin
  TabControl2.ActiveTab := tsBusqueda;
end;

procedure TFMain.TabControl1Gesture(Sender: TObject;
  const EventInfo: TGestureEventInfo; var Handled: Boolean);
begin
{$IFDEF ANDROID}
  case EventInfo.GestureID of
    sgiLeft:
    begin
      if TabControl2.ActiveTab <> TabControl2.Tabs[TabControl2.TabCount-1] then
        TabControl2.ActiveTab := TabControl2.Tabs[TabControl2.TabIndex+1];
      Handled := True;
    end;

    sgiRight:
    begin
      if TabControl2.ActiveTab <> TabControl2.Tabs[0] then
        TabControl2.ActiveTab := TabControl2.Tabs[TabControl2.TabIndex-1];
      Handled := True;
    end;
  end;
{$ENDIF}
end;

end.
